'-----------------------------------------------------------------------------
'           Compact Font load routine ver.1.0 (c) 2000 by CFM-SOFTWARE
'-----------------------------------------------------------------------------
'
' This rountine makes it posible to load and use a font, which is made in
' Font editor and converted in a cpf-format, which reduces the size of the
' file to about 1/8 of the original size.
' There are 2 subroutines in this file:
'
' SUB loadfont(file$) ' load a font in memory
'       - file$      -> name of the font-file
'
' SUB showfont (text$, x%, y%, marg%, fact!) ' show font
'       - text$      -> text, which should be printed
'       - x%         -> x-coordinate in pixels
'       - y%         -> y-coordinate in pixels
'       - marg%      -> marge between to letters(in pixels)
'       - fact!      -> enlarges the text, 1 = normal (8x16)
'       - degr%      -> makes it posible to turn your font
'                       0 - normal
'                       1 - the top of font is turned to the left
'                       2 - the top of font is turned to the right
'                       3 - turns the font upside down
'
' fontname$ -> gives the name of the font
'
' This routine is produced by Coen Martinus in the year 2000. It is based on
' an older routine of mine, which I produced between 1997/1998. This routine
' makes it posible in Q(uick)-Basic to write a text over the background in a
' grafical screen, without removing the background pixels. It is also posible
' to create your own characters.
'
' This routine is free, and your allowed to use this routine in your own
' programs as long as you keep the copyright of this program by the author of
' this routine: Coen Martinus  (The Netherlands, 'European Union')
' E-mail: cfm_mart@hotmail.com
'
' USE ON YOUR OWN RISK / NUTZUNG AUF EIGEN RISIKO / GEBRUIK OP EIGEN RISICO
'
DECLARE FUNCTION ccoin# (a$)
DECLARE FUNCTION maakbin$ (getal#)
DECLARE SUB loadfont (file$)
DECLARE SUB showfont (text$, x%, y%, marg%, fact!, degr%)
DIM SHARED let$(256), fontname$

FUNCTION ccoin# (a$)
FOR r = 1 TO LEN(a$)
        hhh# = hhh# + ASC(MID$(a$, r, 1)) * 256 ^ (LEN(a$) - r)
NEXT r

ccoin# = hhh#

END FUNCTION

SUB loadfont (file$)
OPEN file$ FOR BINARY AS #1
        fontname$ = SPACE$(9)
        GET #1, 1, fontname$
        r = 0
        DO
                let$(r) = SPACE$(16)
                GET #1, 10 + 16 * r, let$(r)
                r = r + 1
        LOOP UNTIL r > (LOF(1) - 10) / 16 OR r = 256
CLOSE #1

END SUB

FUNCTION maakbin$ (getal#)
IF getal# = 0 THEN
a$ = "0"
GOTO hh2
END IF
h = 8 'FIX(LOG(getal#) / LOG(2)) + 1
a$ = SPACE$(h)
'PRINT h
FOR r = 1 TO h
        IF getal# - 2 ^ (h - r) >= 0 THEN
                MID$(a$, r, 1) = "1"
                getal# = getal# - 2 ^ (h - r)
        ELSE
                MID$(a$, r, 1) = "0"
        END IF
NEXT r
hh2:

maakbin$ = a$


END FUNCTION

SUB showfont (text$, x%, y%, marg%, fact!, degr%) ' show font
IF degr% = 2 OR degr% = 3 THEN
        x% = -1 * x%
END IF
oldy = y%
FOR r = 1 TO LEN(text$)
        hu$ = SPACE$(128)
        b = ASC(MID$(text$, r, 1))
        b$ = let$(b)
        IF b$ = "" THEN
                hu$ = STRING$(128, "0")
                GOTO bestaatniet
        END IF
        FOR t = 1 TO 16
                a = a + 1
                h$ = MID$(b$, t, 1)
                MID$(hu$, 1 + (t - 1) * 8) = maakbin$(ASC(h$))
        NEXT t
bestaatniet:
        kol = 0
        row = 1
        FOR q = 1 TO 128
                kol = kol + 1
                IF kol = 9 THEN
                        kol = 1
                        row = row + 1
                ELSE
                END IF
                a = VAL(MID$(hu$, q, 1))
                IF a = 1 THEN
                        IF fact! = 1 THEN
                               d = x% + kol
                               e = y% + row
                               PSET (d, e)
                        ELSE
                               d = x% + kol * fact! - fact!
                               e = y% + row * fact! - fact!
                               f = x% + kol * fact!
                               g = y% + row * fact!
                               LINE (d, e)-(f, g), , BF
        END IF
ELSE
END IF
        

        NEXT q
x% = x% + 8 * fact! + marg%
NEXT r
EXIT SUB

END SUB

